#!/usr/bin/env python3
# 18_zeichenklassen_testen.py

import sys
import re

# Suchbegriff von Kommandozeile holen & abspeichern
try:
    suchbegriff = sys.argv[1]
    # falls keine Sonderzeichen im Suchbegriff vorkommen, die Klassen einleiten, mit passender Fehlermeldung abbrechen
    if not re.search('[.\[\\\]', suchbegriff):
        sys.exit('Keine Zeichenklasse im Suchbegriff definiert!')
# falls kein Argument angegeben wurde
except IndexError:
    # Programm mit geeigneter Fehlermeldung abbrechen
    sys.exit('Keine Suchbegriff definiert!')
# Datei öffnen
try:
    with open('beispiel_saetze.txt', 'r', encoding='utf-8') as datei:
        # über Zeilen iterieren
        for zeile in datei:
            # falls Suchbegriff mindestens einmal gefunden wird...
            if re.search(suchbegriff, zeile):
                # Variable zur Zusammensetzung der neuen Zeile mit Markierungen erstellen
                zeileNeu = ''
                # Startvariable anlegen
                start = 0
                # über alle Treffer auf der Zeile iterieren
                for treffer in re.finditer(suchbegriff,zeile):
                    # Anfangs- & Endpositionen des Treffers bestimmen
                    (anfang,ende) = treffer.span()
                    # alles ab beginn des aktuellen Anfangs bis vor Trefferanfang, linke Klammer, Treffer & rechte Klammer an neue Zeile anhängen
                    zeileNeu += f'{zeile[start:anfang]}[{treffer.group()}]'
                    # Startvariable für nächsten Teil der Zeile auf Ende des Treffers setzen
                    start = ende      
                # am Ende der Schleife neue Zeile & Rest der Zeile, ohne Zeilenumbruch, ausgeben
                print(zeileNeu + zeile[ende:-1])
except OSError as fehler:
    sys.exit(str(fehler))