#!/usr/bin/env python3
# 19_regexes_testen.py

import sys
import re

# Suchbegriff von Kommandozeile holen & abspeichern
try:
    suchbegriff = re.compile(sys.argv[1])
# falls kein Argument angegeben wurde
except IndexError:
    # Programm mit geeigneter Fehlermeldung abbrechen
    sys.exit('Keine Suchbegriff definiert!')
except re.error as e:
    sys.exit(f'Regexfehler="{e.msg}" in Muster: "{e.pattern}" an Position {e.pos}')
# Datei öffnen
try:
    with open('beispiel_saetze.txt', 'r', encoding='utf-8') as datei:
        # über Zeilen iterieren
        for zeile in datei:
            # falls Suchbegriff mindestens einmal gefunden wird...
            if suchbegriff.search(zeile):
                # Variable zur Zusammensetzung der neuen Zeile mit Markierungen erstellen
                zeileNeu = ''
                # Startvariable anlegen
                start = 0
                # über alle Treffer auf der Zeile iterieren
                for treffer in suchbegriff.finditer(zeile):
                    # Anfangs- & Endpositionen des Treffers bestimmen
                    (anfang,ende) = treffer.span()
                    # alles ab beginn des aktuellen Anfangs bis vor Trefferanfang, linke Klammer, Treffer & rechte Klammer an neue Zeile anhängen
                    zeileNeu += f'{zeile[start:anfang]}[{treffer.group()}]'
                    #print(zeileNeu, 'Anfang', anfang, 'Ende', ende)
                    # Startvariable für nächsten Teil der Zeile auf Ende des Treffers setzen
                    start = ende                
                # am Ende der Schleife neue Zeile & Rest der Zeile, ohne Zeilenumbruch, ausgeben
                print(zeileNeu + zeile[ende:-1])
except OSError as fehler:
    sys.exit(str(fehler))