#!/usr/bin/env python3
# 21_wortliste.py

import re
import sys
import os.path

woerter = []
eingabe_datei = './kafka_verwandlung.txt'
pfad, dateiname = os.path.split(eingabe_datei)
ausgabe_datei = os.path.join(pfad, 'wortliste_' + dateiname)

try:
    with open(eingabe_datei, 'r', encoding='utf-8') as datei:
        for zeile in datei:
            zeile = re.sub(r'[»«.,;!?:-]',' ', zeile)
            zeile = re.sub(r'\s{2,}', ' ', zeile)
            zeile = zeile.strip()
            if not zeile:
                continue
            woerter.extend(re.split(r'\s', zeile))
except OSError as fehler:
    sys.exit(str(fehler))

try:
    with open(ausgabe_datei, mode='w', encoding='utf-8') as datei:
        for wort in sorted(set(woerter), key=str.casefold):
            datei.write(wort + '\n')
except OSError as fehler:
    sys.exit(str(fehler))