#!/usr/bin/env python3
# 22_frequenzliste.py

import re
import sys
import os.path

woerter = {}
eingabe_datei = '../texte/kafka_verwandlung.txt'
pfad, dateiname = os.path.split(eingabe_datei)
ausgabe_datei = os.path.join(pfad, 'frequenzliste_' + dateiname)
laengstes_wort = 0

try:
    with open(eingabe_datei, 'r', encoding='utf-8') as datei:
        for zeile in datei:
            zeile = re.sub(r'[»«.,;!?:-]','', zeile)
            zeile = re.sub(r'\s{2,}', ' ', zeile)
            zeile = zeile.strip()
            if not zeile:
                continue
            for wort in re.split(r'\s', zeile):
                woerter[wort] = woerter.setdefault(wort, 0) + 1
                if len(wort) > laengstes_wort:
                    laengstes_wort = len(wort)
except OSError as fehler:
    sys.exit(str(fehler))

try:
    with open(ausgabe_datei, 'w', encoding='utf-8') as datei:
        for wort in sorted(woerter.keys(), key=str.casefold):
            datei.write(f'{wort:{laengstes_wort}}\t{woerter[wort]}\n')
except OSError as fehler:
    sys.exit(str(fehler))