#!/usr/bin/env python3
# author: Martin Weisser
# 23_seite_holen.py

import urllib.request
import re
import sys

adresse=\
'http://martinweisser.org/pract_cl/HTML_download_test_de.html'
try:
    print(f'Versuche {adresse} herunterzuladen...')
    seite=urllib.request.urlopen(adresse)
    print(f'Type des Objekts = {type(seite)}')
except urllib.error.URLError as fehler:
    sys.exit(f'Fehler beim herunterladen.\n{adresse} {fehler.reason}')
print(f'Seite {adresse} erfolgreich heruntergeladen')

print('Suche nach Kodierung & Seitentitel...')
# Kodierung über Header-Info finden
kodierung=seite.headers.get_content_charset(failobj="utf-8")
try:
    seiteninhalt=seite.read().decode(kodierung)
except Exception:
    sys.exit('Unable to decode URL. Aborting download.\n')
    return
# nach Titel suchen
titel=\
  re.search(r'<title>\s*([^<]+?)\s*</title>', seiteninhalt).group(1)
if kodierung and titel:
    print('Kodierung:', kodierung,'& Titel:',titel)

# Dateinamen generieren
print('Erzeuge Dateinamen...')
# entweder aus Titel, falls gefunden oder sonst Addresse
if titel:
    dateiName=re.sub(r' ',r'_',titel) + '.html'
else:
    dateiName=adresse[adresse.rindex('/')+1:]
print('Versuche Seiteninhalt von', adresse,'abzuspeichern...')
try:
    with open(dateiName,mode='w',encoding='utf-8') as aus:
        aus.write(seiteninhalt)
except OSError as fehler:
    sys.exit(str(fehler))
print(adresse,'erfolgreich als',dateiName,'abgespeichert.')