#!/usr/bin/env python3
# uebersetzer.py
import re
import sys


def woerterbuch_lesen(woerterbuch_datei):
    woerterbuch = {}
    try:
        with open(woerterbuch_datei, 'r', encoding='utf-8') as wb:
            for zeile in wb:
                zeile = zeile.strip()
                if zeile:
                    wort, uebersetzung = zeile.split(':')
                    woerterbuch[wort] = uebersetzung
    except OSError as fehler:
        sys.exit(str(fehler))
    return woerterbuch

def saetze_lesen(satz_datei):
    saetze = []
    try:
        with open(satz_datei, 'r', encoding='utf-8') as sd:
            for zeile in sd:
                zeile = zeile.strip()
                if zeile:
                    saetze.append(zeile)
    except OSError as fehler:
        sys.exit(str(fehler))
    return saetze

def uebersetzen(woerterbuch, satz):
    uebersetzungen = list()
    satz = satz[0:1].lower() + satz[1:-1]
    for wort in re.split(r'\s', satz):
        if wort in woerterbuch:
            uebersetzungen.append(woerterbuch[wort])
        else: 
            uebersetzungen.append('???')
    return ' '.join(uebersetzungen).capitalize() + '.'

def uebersetzung_ausgeben(satz, uebersetzung):
        # print('Original: ' + satz + '\tÜbersetzung: ' + uebersetzung)
        print('\n'.join(['Original: ', satz, 'Übersetzung:', uebersetzung]))